/*
 @pixiv/three-vrm-animation v2.1.3
 The implementation of VRM Animation

 Copyright (c) 2023-2024 pixiv Inc.
 @pixiv/three-vrm-animation is distributed under MIT License
 https://github.com/pixiv/three-vrm/blob/release/LICENSE
 @pixiv/three-vrm-core v2.1.3
 The implementation of core features of VRM, for @pixiv/three-vrm

 Copyright (c) 2020-2024 pixiv Inc.
 @pixiv/three-vrm-core is distributed under MIT License
 https://github.com/pixiv/three-vrm/blob/release/LICENSE
*/
'use strict';(function(global,factory){typeof exports==="object"&&typeof module!=="undefined"?factory(exports,require("three")):typeof define==="function"&&define.amd?define(["exports","three"],factory):(global=typeof globalThis!=="undefined"?globalThis:global||self,factory(global.THREE_VRM_ANIMATION={},global.THREE))})(this,function(exports,THREE){function _interopNamespace(e){if(e&&e.__esModule)return e;var n=Object.create(null);if(e)Object.keys(e).forEach(function(k){if(k!=="default"){var d=Object.getOwnPropertyDescriptor(e,
k);Object.defineProperty(n,k,d.get?d:{enumerable:true,get:function(){return e[k]}})}});n["default"]=e;return Object.freeze(n)}var THREE__namespace=_interopNamespace(THREE);typeof SuppressedError==="function"?SuppressedError:function(error,suppressed,message){var e=new Error(message);return e.name="SuppressedError",e.error=error,e.suppressed=suppressed,e};const VRMExpressionPresetName={Aa:"aa",Ih:"ih",Ou:"ou",Ee:"ee",Oh:"oh",Blink:"blink",Happy:"happy",Angry:"angry",Sad:"sad",Relaxed:"relaxed",LookUp:"lookUp",
Surprised:"surprised",LookDown:"lookDown",LookLeft:"lookLeft",LookRight:"lookRight",BlinkLeft:"blinkLeft",BlinkRight:"blinkRight",Neutral:"neutral"};new THREE__namespace.Color;new THREE__namespace.Vector2;new THREE__namespace.Vector3;new THREE__namespace.Vector3;new THREE__namespace.Quaternion;const VRMHumanBoneParentMap={hips:null,spine:"hips",chest:"spine",upperChest:"chest",neck:"upperChest",head:"neck",leftEye:"head",rightEye:"head",jaw:"head",leftUpperLeg:"hips",leftLowerLeg:"leftUpperLeg",leftFoot:"leftLowerLeg",
leftToes:"leftFoot",rightUpperLeg:"hips",rightLowerLeg:"rightUpperLeg",rightFoot:"rightLowerLeg",rightToes:"rightFoot",leftShoulder:"upperChest",leftUpperArm:"leftShoulder",leftLowerArm:"leftUpperArm",leftHand:"leftLowerArm",rightShoulder:"upperChest",rightUpperArm:"rightShoulder",rightLowerArm:"rightUpperArm",rightHand:"rightLowerArm",leftThumbMetacarpal:"leftHand",leftThumbProximal:"leftThumbMetacarpal",leftThumbDistal:"leftThumbProximal",leftIndexProximal:"leftHand",leftIndexIntermediate:"leftIndexProximal",
leftIndexDistal:"leftIndexIntermediate",leftMiddleProximal:"leftHand",leftMiddleIntermediate:"leftMiddleProximal",leftMiddleDistal:"leftMiddleIntermediate",leftRingProximal:"leftHand",leftRingIntermediate:"leftRingProximal",leftRingDistal:"leftRingIntermediate",leftLittleProximal:"leftHand",leftLittleIntermediate:"leftLittleProximal",leftLittleDistal:"leftLittleIntermediate",rightThumbMetacarpal:"rightHand",rightThumbProximal:"rightThumbMetacarpal",rightThumbDistal:"rightThumbProximal",rightIndexProximal:"rightHand",
rightIndexIntermediate:"rightIndexProximal",rightIndexDistal:"rightIndexIntermediate",rightMiddleProximal:"rightHand",rightMiddleIntermediate:"rightMiddleProximal",rightMiddleDistal:"rightMiddleIntermediate",rightRingProximal:"rightHand",rightRingIntermediate:"rightRingProximal",rightRingDistal:"rightRingIntermediate",rightLittleProximal:"rightHand",rightLittleIntermediate:"rightLittleProximal",rightLittleDistal:"rightLittleIntermediate"};function quatInvertCompat(target){if(target.invert)target.invert();
else target.inverse();return target}new THREE__namespace.Vector3;new THREE__namespace.Quaternion;new THREE__namespace.Vector3;new THREE__namespace.Quaternion;new THREE__namespace.Vector3;new THREE__namespace.Quaternion;new THREE__namespace.Quaternion;new THREE__namespace.Vector3;new THREE__namespace.Vector3;const SQRT_2_OVER_2=Math.sqrt(2)/2;new THREE__namespace.Quaternion(0,0,-SQRT_2_OVER_2,SQRT_2_OVER_2);new THREE__namespace.Vector3(0,1,0);const _position=new THREE__namespace.Vector3;const _scale=
new THREE__namespace.Vector3;function getWorldQuaternionLite(object,out){object.matrixWorld.decompose(_position,out,_scale);return out}function calcAzimuthAltitude(vector){return[Math.atan2(-vector.z,vector.x),Math.atan2(vector.y,Math.sqrt(vector.x*vector.x+vector.z*vector.z))]}function sanitizeAngle(angle){const roundTurn=Math.round(angle/2/Math.PI);return angle-2*Math.PI*roundTurn}const VEC3_POSITIVE_Z$1=new THREE__namespace.Vector3(0,0,1);const _v3A$1=new THREE__namespace.Vector3;const _v3B=new THREE__namespace.Vector3;
const _v3C=new THREE__namespace.Vector3;const _quatA$1=new THREE__namespace.Quaternion;const _quatB$1=new THREE__namespace.Quaternion;const _quatC$1=new THREE__namespace.Quaternion;const _quatD=new THREE__namespace.Quaternion;const _eulerA$1=new THREE__namespace.Euler;class VRMLookAt{get yaw(){return this._yaw}set yaw(value){this._yaw=value;this._needsUpdate=true}get pitch(){return this._pitch}set pitch(value){this._pitch=value;this._needsUpdate=true}get euler(){console.warn("VRMLookAt: euler is deprecated. use getEuler() instead.");
return this.getEuler(new THREE__namespace.Euler)}constructor(humanoid,applier){this.offsetFromHeadBone=new THREE__namespace.Vector3;this.autoUpdate=true;this.faceFront=new THREE__namespace.Vector3(0,0,1);this.humanoid=humanoid;this.applier=applier;this._yaw=0;this._pitch=0;this._needsUpdate=true;this._restHeadWorldQuaternion=this.getLookAtWorldQuaternion(new THREE__namespace.Quaternion)}getEuler(target){return target.set(THREE__namespace.MathUtils.DEG2RAD*this._pitch,THREE__namespace.MathUtils.DEG2RAD*
this._yaw,0,"YXZ")}copy(source){if(this.humanoid!==source.humanoid)throw new Error("VRMLookAt: humanoid must be same in order to copy");this.offsetFromHeadBone.copy(source.offsetFromHeadBone);this.applier=source.applier;this.autoUpdate=source.autoUpdate;this.target=source.target;this.faceFront.copy(source.faceFront);return this}clone(){return(new VRMLookAt(this.humanoid,this.applier)).copy(this)}reset(){this._yaw=0;this._pitch=0;this._needsUpdate=true}getLookAtWorldPosition(target){const head=this.humanoid.getRawBoneNode("head");
return target.copy(this.offsetFromHeadBone).applyMatrix4(head.matrixWorld)}getLookAtWorldQuaternion(target){const head=this.humanoid.getRawBoneNode("head");return getWorldQuaternionLite(head,target)}getFaceFrontQuaternion(target){if(this.faceFront.distanceToSquared(VEC3_POSITIVE_Z$1)<.01)return target.copy(this._restHeadWorldQuaternion).invert();const [faceFrontAzimuth,faceFrontAltitude]=calcAzimuthAltitude(this.faceFront);_eulerA$1.set(0,.5*Math.PI+faceFrontAzimuth,faceFrontAltitude,"YZX");return target.setFromEuler(_eulerA$1).premultiply(_quatD.copy(this._restHeadWorldQuaternion).invert())}getLookAtWorldDirection(target){this.getLookAtWorldQuaternion(_quatB$1);
this.getFaceFrontQuaternion(_quatC$1);return target.copy(VEC3_POSITIVE_Z$1).applyQuaternion(_quatB$1).applyQuaternion(_quatC$1).applyEuler(this.getEuler(_eulerA$1))}lookAt(position){const headRotDiffInv=_quatA$1.copy(this._restHeadWorldQuaternion).multiply(quatInvertCompat(this.getLookAtWorldQuaternion(_quatB$1)));const headPos=this.getLookAtWorldPosition(_v3B);const lookAtDir=_v3C.copy(position).sub(headPos).applyQuaternion(headRotDiffInv).normalize();const [azimuthFrom,altitudeFrom]=calcAzimuthAltitude(this.faceFront);
const [azimuthTo,altitudeTo]=calcAzimuthAltitude(lookAtDir);const yaw=sanitizeAngle(azimuthTo-azimuthFrom);const pitch=sanitizeAngle(altitudeFrom-altitudeTo);this._yaw=THREE__namespace.MathUtils.RAD2DEG*yaw;this._pitch=THREE__namespace.MathUtils.RAD2DEG*pitch;this._needsUpdate=true}update(delta){if(this.target!=null&&this.autoUpdate)this.lookAt(this.target.getWorldPosition(_v3A$1));if(this._needsUpdate){this._needsUpdate=false;this.applier.applyYawPitch(this._yaw,this._pitch)}}}VRMLookAt.EULER_ORDER=
"YXZ";new THREE__namespace.Vector3(0,0,1);new THREE__namespace.Quaternion;new THREE__namespace.Quaternion;new THREE__namespace.Euler(0,0,0,"YXZ");const RAD2DEG=180/Math.PI;const _eulerA=new THREE__namespace.Euler;class VRMLookAtQuaternionProxy extends THREE__namespace.Object3D{constructor(lookAt){super();this.vrmLookAt=lookAt;this.type="VRMLookAtQuaternionProxy";const prevRotationOnChangeCallback=this.rotation._onChangeCallback;this.rotation._onChange(()=>{prevRotationOnChangeCallback();this._applyToLookAt()});
const prevQuaternionOnChangeCallback=this.quaternion._onChangeCallback;this.quaternion._onChange(()=>{prevQuaternionOnChangeCallback();this._applyToLookAt()})}_applyToLookAt(){_eulerA.setFromQuaternion(this.quaternion,VRMLookAt.EULER_ORDER);this.vrmLookAt.yaw=RAD2DEG*_eulerA.y;this.vrmLookAt.pitch=RAD2DEG*_eulerA.x}}function createVRMAnimationHumanoidTracks(vrmAnimation,humanoid,metaVersion){var _a,_b;const translation=new Map;const rotation=new Map;for(const [name,origTrack]of vrmAnimation.humanoidTracks.rotation.entries()){const nodeName=
(_a=humanoid.getNormalizedBoneNode(name))===null||_a===void 0?void 0:_a.name;if(nodeName!=null){const track=new THREE__namespace.QuaternionKeyframeTrack(`${nodeName}.quaternion`,origTrack.times,origTrack.values.map((v,i)=>metaVersion==="0"&&i%2===0?-v:v));rotation.set(name,track)}}for(const [name,origTrack]of vrmAnimation.humanoidTracks.translation.entries()){const nodeName=(_b=humanoid.getNormalizedBoneNode(name))===null||_b===void 0?void 0:_b.name;if(nodeName!=null){const animationY=vrmAnimation.restHipsPosition.y;
const humanoidY=humanoid.normalizedRestPose.hips.position[1];const scale=humanoidY/animationY;const track=origTrack.clone();track.values=track.values.map((v,i)=>(metaVersion==="0"&&i%3!==1?-v:v)*scale);track.name=`${nodeName}.position`;translation.set(name,track)}}return{translation,rotation}}function createVRMAnimationExpressionTracks(vrmAnimation,expressionManager){const preset=new Map;const custom=new Map;for(const [name,origTrack]of vrmAnimation.expressionTracks.preset.entries()){const trackName=
expressionManager.getExpressionTrackName(name);if(trackName!=null){const track=origTrack.clone();track.name=trackName;preset.set(name,track)}}for(const [name,origTrack]of vrmAnimation.expressionTracks.custom.entries()){const trackName=expressionManager.getExpressionTrackName(name);if(trackName!=null){const track=origTrack.clone();track.name=trackName;custom.set(name,track)}}return{preset,custom}}function createVRMAnimationLookAtTrack(vrmAnimation,trackName){if(vrmAnimation.lookAtTrack==null)return null;
const track=vrmAnimation.lookAtTrack.clone();track.name=trackName;return track}function createVRMAnimationClip(vrmAnimation,vrm){const tracks=[];const humanoidTracks=createVRMAnimationHumanoidTracks(vrmAnimation,vrm.humanoid,vrm.meta.metaVersion);tracks.push(...humanoidTracks.translation.values());tracks.push(...humanoidTracks.rotation.values());if(vrm.expressionManager!=null){const expressionTracks=createVRMAnimationExpressionTracks(vrmAnimation,vrm.expressionManager);tracks.push(...expressionTracks.preset.values());
tracks.push(...expressionTracks.custom.values())}if(vrm.lookAt!=null){let proxy=vrm.scene.children.find(obj=>obj instanceof VRMLookAtQuaternionProxy);if(proxy==null){console.warn("createVRMAnimationClip: VRMLookAtQuaternionProxy is not found. Creating a new one automatically. To suppress this warning, create a VRMLookAtQuaternionProxy manually");proxy=new VRMLookAtQuaternionProxy(vrm.lookAt);proxy.name="VRMLookAtQuaternionProxy";vrm.scene.add(proxy)}else if(proxy.name==null){console.warn("createVRMAnimationClip: VRMLookAtQuaternionProxy is found but its name is not set. Setting the name automatically. To suppress this warning, set the name manually");
proxy.name="VRMLookAtQuaternionProxy"}const track=createVRMAnimationLookAtTrack(vrmAnimation,`${proxy.name}.quaternion`);if(track!=null)tracks.push(track)}return new THREE__namespace.AnimationClip("Clip",vrmAnimation.duration,tracks)}class VRMAnimation{constructor(){this.duration=0;this.restHipsPosition=new THREE__namespace.Vector3;this.humanoidTracks={translation:new Map,rotation:new Map};this.expressionTracks={preset:new Map,custom:new Map};this.lookAtTrack=null}}function __awaiter(thisArg,_arguments,
P,generator){function adopt(value){return value instanceof P?value:new P(function(resolve){resolve(value)})}return new (P||(P=Promise))(function(resolve,reject){function fulfilled(value){try{step(generator.next(value))}catch(e){reject(e)}}function rejected(value){try{step(generator["throw"](value))}catch(e){reject(e)}}function step(result){result.done?resolve(result.value):adopt(result.value).then(fulfilled,rejected)}step((generator=generator.apply(thisArg,_arguments||[])).next())})}typeof SuppressedError===
"function"?SuppressedError:function(error,suppressed,message){var e=new Error(message);return e.name="SuppressedError",e.error=error,e.suppressed=suppressed,e};function arrayChunk(array,every){const N=array.length;const ret=[];let current=[];let remaining=0;for(let i=0;i<N;i++){const el=array[i];if(remaining<=0){remaining=every;current=[];ret.push(current)}current.push(el);remaining--}return ret}const MAT4_IDENTITY=new THREE__namespace.Matrix4;const _v3A=new THREE__namespace.Vector3;const _quatA=
new THREE__namespace.Quaternion;const _quatB=new THREE__namespace.Quaternion;const _quatC=new THREE__namespace.Quaternion;const POSSIBLE_SPEC_VERSIONS=new Set(["1.0","1.0-draft"]);const vrmExpressionPresetNameSet=new Set(Object.values(VRMExpressionPresetName));class VRMAnimationLoaderPlugin{constructor(parser){this.parser=parser}get name(){return"VRMC_vrm_animation"}afterRoot(gltf){var _a,_b,_c;return __awaiter(this,void 0,void 0,function*(){const defGltf=gltf.parser.json;const defExtensionsUsed=
defGltf.extensionsUsed;if(defExtensionsUsed==null||defExtensionsUsed.indexOf(this.name)==-1)return;const defExtension=(_a=defGltf.extensions)===null||_a===void 0?void 0:_a[this.name];if(defExtension==null)return;let specVersion=defExtension.specVersion;if(!specVersion)specVersion="1.0-draft";if(!POSSIBLE_SPEC_VERSIONS.has(specVersion)){console.warn(`VRMAnimationLoaderPlugin: Unknown VRMC_vrm_animation spec version: ${specVersion}`);return}if(specVersion==="1.0-draft");const nodeMap=this._createNodeMap(defExtension);
const worldMatrixMap=yield this._createBoneWorldMatrixMap(gltf,defExtension);const hipsNode=(_c=(_b=defExtension.humanoid)===null||_b===void 0?void 0:_b.humanBones["hips"])===null||_c===void 0?void 0:_c.node;const hips=hipsNode!=null?yield gltf.parser.getDependency("node",hipsNode):null;const restHipsPosition=new THREE__namespace.Vector3;hips===null||hips===void 0?void 0:hips.getWorldPosition(restHipsPosition);const clips=gltf.animations;const animations=clips.map((clip,iAnimation)=>{const defAnimation=
defGltf.animations[iAnimation];const animation=this._parseAnimation(clip,defAnimation,nodeMap,worldMatrixMap);animation.restHipsPosition=restHipsPosition;return animation});gltf.userData.vrmAnimations=animations})}_createNodeMap(defExtension){var _a,_b,_c,_d,_e;const humanoidIndexToName=new Map;const expressionsIndexToName=new Map;const humanBones=(_a=defExtension.humanoid)===null||_a===void 0?void 0:_a.humanBones;if(humanBones)Object.entries(humanBones).forEach(([name,bone])=>{const node=bone===
null||bone===void 0?void 0:bone.node;if(node!=null)humanoidIndexToName.set(node,name)});const preset=(_b=defExtension.expressions)===null||_b===void 0?void 0:_b.preset;if(preset)Object.entries(preset).forEach(([name,expression])=>{const node=expression===null||expression===void 0?void 0:expression.node;if(node!=null)expressionsIndexToName.set(node,name)});const custom=(_c=defExtension.expressions)===null||_c===void 0?void 0:_c.custom;if(custom)Object.entries(custom).forEach(([name,expression])=>{const {node}=
expression;expressionsIndexToName.set(node,name)});const lookAtIndex=(_e=(_d=defExtension.lookAt)===null||_d===void 0?void 0:_d.node)!==null&&_e!==void 0?_e:null;return{humanoidIndexToName,expressionsIndexToName,lookAtIndex}}_createBoneWorldMatrixMap(gltf,defExtension){var _a,_b;return __awaiter(this,void 0,void 0,function*(){gltf.scene.updateWorldMatrix(false,true);const threeNodes=yield gltf.parser.getDependencies("node");const worldMatrixMap=new Map;if(defExtension.humanoid==null)return worldMatrixMap;
for(const [boneName,humanBone]of Object.entries(defExtension.humanoid.humanBones)){const node=humanBone===null||humanBone===void 0?void 0:humanBone.node;if(node!=null){const threeNode=threeNodes[node];worldMatrixMap.set(boneName,threeNode.matrixWorld);if(boneName==="hips")worldMatrixMap.set("hipsParent",(_b=(_a=threeNode.parent)===null||_a===void 0?void 0:_a.matrixWorld)!==null&&_b!==void 0?_b:MAT4_IDENTITY)}}return worldMatrixMap})}_parseAnimation(animationClip,defAnimation,nodeMap,worldMatrixMap){const tracks=
animationClip.tracks;const defChannels=defAnimation.channels;const result=new VRMAnimation;result.duration=animationClip.duration;defChannels.forEach((channel,iChannel)=>{const {node,path}=channel.target;const origTrack=tracks[iChannel];if(node==null)return;const boneName=nodeMap.humanoidIndexToName.get(node);if(boneName!=null){let parentBoneName=VRMHumanBoneParentMap[boneName];while(parentBoneName!=null&&worldMatrixMap.get(parentBoneName)==null)parentBoneName=VRMHumanBoneParentMap[parentBoneName];
parentBoneName!==null&&parentBoneName!==void 0?parentBoneName:parentBoneName="hipsParent";if(path==="translation")if(boneName!=="hips")console.warn(`The loading animation contains a translation track for ${boneName}, which is not permitted in the VRMC_vrm_animation spec. ignoring the track`);else{const hipsParentWorldMatrix=worldMatrixMap.get("hipsParent");const trackValues=arrayChunk(origTrack.values,3).flatMap(v=>_v3A.fromArray(v).applyMatrix4(hipsParentWorldMatrix).toArray());const track=origTrack.clone();
track.values=new Float32Array(trackValues);result.humanoidTracks.translation.set(boneName,track)}else if(path==="rotation"){const worldMatrix=worldMatrixMap.get(boneName);const parentWorldMatrix=worldMatrixMap.get(parentBoneName);worldMatrix.decompose(_v3A,_quatA,_v3A);_quatA.invert();parentWorldMatrix.decompose(_v3A,_quatB,_v3A);const trackValues=arrayChunk(origTrack.values,4).flatMap(q=>_quatC.fromArray(q).premultiply(_quatB).multiply(_quatA).toArray());const track=origTrack.clone();track.values=
new Float32Array(trackValues);result.humanoidTracks.rotation.set(boneName,track)}else throw new Error(`Invalid path "${path}"`);return}const expressionName=nodeMap.expressionsIndexToName.get(node);if(expressionName!=null){if(path==="translation"){const times=origTrack.times;const values=new Float32Array(origTrack.values.length/3);for(let i=0;i<values.length;i++)values[i]=origTrack.values[3*i];const newTrack=new THREE__namespace.NumberKeyframeTrack(`${expressionName}.weight`,times,values);if(vrmExpressionPresetNameSet.has(expressionName))result.expressionTracks.preset.set(expressionName,
newTrack);else result.expressionTracks.custom.set(expressionName,newTrack)}else throw new Error(`Invalid path "${path}"`);return}if(node===nodeMap.lookAtIndex)if(path==="rotation")result.lookAtTrack=origTrack;else throw new Error(`Invalid path "${path}"`);});return result}}exports.VRMAnimation=VRMAnimation;exports.VRMAnimationLoaderPlugin=VRMAnimationLoaderPlugin;exports.VRMLookAtQuaternionProxy=VRMLookAtQuaternionProxy;exports.createVRMAnimationClip=createVRMAnimationClip;exports.createVRMAnimationExpressionTracks=
createVRMAnimationExpressionTracks;exports.createVRMAnimationHumanoidTracks=createVRMAnimationHumanoidTracks;exports.createVRMAnimationLookAtTrack=createVRMAnimationLookAtTrack;Object.defineProperty(exports,"__esModule",{value:true});Object.assign(THREE,exports)});